# Uses of Interface
com.sun.source.tree.TreeVisitor

Packages that use TreeVisitor
Package
Description
com.sun.source.tree
Provides interfaces to represent source code as abstract syntax trees (AST).
com.sun.source.util
Provides utilities for operations on abstract syntax trees (AST).

## Uses of TreeVisitor in com.sun.source.tree

Methods in com.sun.source.tree with parameters of type TreeVisitor
Modifier and Type
Method
Description
`<R, D> R`
Tree.`accept(TreeVisitor<R,D> visitor, D data)`
Accept method used to implement the visitor pattern.

## Uses of TreeVisitor in com.sun.source.util

Classes in com.sun.source.util that implement TreeVisitor
Modifier and Type
Class
Description
`class`
`SimpleTreeVisitor<R,P>`
A simple visitor for tree nodes.
`class`
`TreePathScanner<R,P>`
A TreeVisitor that visits all the child tree nodes, and provides support for maintaining a path for the parent nodes.
`class`
`TreeScanner<R,P>`
A TreeVisitor that visits all the child tree nodes.